#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>

static gboolean delete_event (GtkWidget *widget, GdkEvent *event, gpointer data)
{
	g_print("delete event occurred\n");
	gtk_main_quit();
	return FALSE;
}

static void destroy (GtkWidget *widget, gpointer data)
{
	gtk_main_quit();
}
static void menu_event (GtkWidget *w, gpointer data)
{
	printf("menu event\n");
}

static GtkItemFactoryEntry menu_items[] = {
	{	"/_File",			NULL,		NULL,			0,	"<Branch>"	},
	{	"/_File/_Quit",		"<CTRL>Q",	gtk_main_quit,	0,	"<StockItem>", GTK_STOCK_QUIT	},
	{	"/_View",			NULL,		NULL,			0,	"<Branch>"	},
	{	"/_View/Hub list",	NULL,		NULL,		0,	"<StockItem>", GTK_STOCK_NETWORK	},
	{	"/_View/Search",	NULL,		NULL,		0,	"<StockItem>", GTK_STOCK_FIND	},
	{	"/_View/Downloads",	NULL,		NULL,		0,	"<StockItem>", GTK_STOCK_GO_DOWN	},
	{	"/_View/Favourites",	NULL,	NULL,		0,	"<StockItem>", GTK_STOCK_INDEX	},
	{	"/_View/Settings",	NULL,		NULL,		0,	"<StockItem>", GTK_STOCK_PREFERENCES	},
	{	"/_Transfers",		NULL,		NULL,		0,	"<Branch>"	},
	{	"/_Transfers/Start download",		NULL,		NULL,		0,	"<StockItem>", GTK_STOCK_MEDIA_PLAY	},
	{	"/_Transfers/Pause download",	NULL,	NULL,	0,	"<StockItem>", GTK_STOCK_MEDIA_PAUSE	},
	{	"/_Transfers/Stop download",	NULL,	NULL,	0,	"<StockItem>", GTK_STOCK_MEDIA_STOP	},
		
	{	"/_Transfers/St_op all downloads",	NULL,	NULL,	0,	"<StockItem>", GTK_STOCK_MEDIA_STOP	},
	{	"/_Transfers/Pause all downloads",	NULL,	NULL,	0,	"<StockItem>", GTK_STOCK_MEDIA_PAUSE	},
		{	"/_Transfers/Resume all downloads",	NULL,	NULL,	0,	"<StockItem>", GTK_STOCK_MEDIA_PLAY	},
	
	{	"/_Help",			NULL,		NULL,			0,	"<LastBranch>"	},
	{	"/_Help/About",		NULL,		NULL,			0,	"<StockItem>", GTK_STOCK_ABOUT	}
};
static gint menuitem_count = sizeof(menu_items) / sizeof (menu_items[0]);

enum {
	DOWNLOADS_COL1_FILE = 0,
	DOWNLOADS_COL2_SIZE,
	DOWNLOADS_COL3_PROGRESS,
	DOWNLOADS_COL4_PERCENT,
	DOWNLOADS_COL5_USER,
	DOWNLOADS_COL6_HUB
};

GtkWidget *create_tab_search (void);
GtkWidget *create_tab_chat (void);

int main (int argc, char *argv[])
{
	GtkWidget *mainwindow, *menu_main, *tbar_main;
	GtkWidget *icn_settings, *icn_favourites, *icn_dllist, *icn_search, *icn_hublist;
	GtkWidget *icn_brax;
	GtkWidget *vbx_main, *hbx_status, *hbx_bar;
	GtkWidget *lbl_status_msg, *lbl_status_upl, *lbl_status_downl, *lbl_status_up, *lbl_status_down;
	GtkWidget *vpn_main, *scrw_downloads, *ntb_work;
	GtkWidget *tbl_downloads;
	GtkWidget *lbl_ex_file, *pgrb_ex_progress, *lbl_ex_speed, *lbl_ex_user, *lbl_ex_hub;
	GtkItemFactory *itmf_menu_main;
	GtkAccelGroup *aclg_menu_main;
	
	GtkListStore *lstr_downloads;
	GtkTreeIter iter;
	GtkWidget *trvw_downloads;
	GtkTreeViewColumn *trvw_col;
	GtkTreeModel *trvw_model;
	GtkCellRenderer *trvw_crend;
	
	gtk_init(&argc, &argv);
			

	mainwindow = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW (mainwindow), "Wiredash");
	gtk_container_set_border_width(GTK_CONTAINER (mainwindow), 0);
	
	g_signal_connect(G_OBJECT (mainwindow), "delete_event",
		G_CALLBACK (delete_event), NULL);
	

	gtk_widget_realize(mainwindow);
	vbx_main = gtk_vbox_new(FALSE, 1);
	
	
	/* setup menu */
	aclg_menu_main = gtk_accel_group_new();
	itmf_menu_main = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", aclg_menu_main);
	gtk_item_factory_create_items(itmf_menu_main, menuitem_count, menu_items, NULL);
	gtk_window_add_accel_group(GTK_WINDOW (mainwindow), aclg_menu_main);
	
	menu_main = gtk_item_factory_get_widget(itmf_menu_main, "<main>");
	
	/* Create and init the menu bar */

	printf("1\n");
	gtk_box_pack_start(GTK_BOX (vbx_main), menu_main, FALSE, FALSE, 0);

	/* Create and init the toolbar / toolbar handlebox */
	hbx_bar = gtk_hbox_new(FALSE, 0);
	tbar_main = gtk_toolbar_new();
	printf("1\n");
	gtk_box_pack_start(GTK_BOX (vbx_main), hbx_bar, FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX (hbx_bar), tbar_main, TRUE, TRUE, 0);
//	gtk_box_pack_end(GTK_BOX (hbx_bar), icn_brax, FALSE, FALSE, 0);
	printf("2\n");
	gtk_toolbar_set_orientation(GTK_TOOLBAR (tbar_main), GTK_ORIENTATION_HORIZONTAL);
	gtk_toolbar_set_style(GTK_TOOLBAR (tbar_main), GTK_TOOLBAR_ICONS);
	gtk_toolbar_set_tooltips(GTK_TOOLBAR (tbar_main), TRUE);

	printf("3\n");
	icn_hublist = gtk_image_new_from_file("tmp.xpm");
	icn_search = gtk_image_new_from_file("tmp.xpm");
	icn_dllist = gtk_image_new_from_file("tmp.xpm");
	icn_favourites = gtk_image_new_from_file("icon-favhubs.png");
	icn_settings = gtk_image_new_from_file("tmp.xpm");
	


	gtk_toolbar_append_item(GTK_TOOLBAR (tbar_main), "Hub list",
		"Open the public hub list", "fixme", icn_hublist,
		GTK_SIGNAL_FUNC (delete_event), NULL);
//	gtk_toolbar_append_space(GTK_TOOLBAR (tbar_main));
	
	gtk_toolbar_append_item(GTK_TOOLBAR (tbar_main), "Search",
		"Search for files", "fixme", icn_search,
		GTK_SIGNAL_FUNC (delete_event), NULL);
//	gtk_toolbar_append_space(GTK_TOOLBAR (tbar_main));

	gtk_toolbar_append_item(GTK_TOOLBAR (tbar_main), "Downloads",
		"Open the download list", "fixme", icn_dllist,
		GTK_SIGNAL_FUNC (delete_event), NULL);
//	gtk_toolbar_append_space(GTK_TOOLBAR (tbar_main));
	
	gtk_toolbar_append_item(GTK_TOOLBAR (tbar_main), "Favourites",
		"Open the favourite hub list", "fixme", icn_favourites,
		GTK_SIGNAL_FUNC (delete_event), NULL);
//	gtk_toolbar_append_space(GTK_TOOLBAR (tbar_main));

	gtk_toolbar_append_item(GTK_TOOLBAR (tbar_main), "Settings",
		"Open the Wiredash configuration dialog", "fixme", icn_settings,
		GTK_SIGNAL_FUNC (delete_event), NULL);

	gtk_toolbar_append_space(GTK_TOOLBAR (tbar_main));
/*
	gtk_toolbar_append_item(GTK_TOOLBAR (tbar_main), "Stop",
		"Stop the selected transfers", "fixme", icn_settings,
		GTK_SIGNAL_FUNC (delete_event), NULL);

	gtk_toolbar_append_item(GTK_TOOLBAR (tbar_main), "Stop",
		"Stop the selected transfers", "fixme", icn_settings,
		GTK_SIGNAL_FUNC (delete_event), NULL);
	
	gtk_toolbar_append_item(GTK_TOOLBAR (tbar_main), "Stop",
		"Stop the selected transfers", "fixme", icn_settings,
		GTK_SIGNAL_FUNC (delete_event), NULL);

	gtk_toolbar_append_item(GTK_TOOLBAR (tbar_main), "Stop",
		"Stop the selected transfers", "fixme", icn_settings,
		GTK_SIGNAL_FUNC (delete_event), NULL);

*/
	printf("4\n");

	printf("5\n");
	
	/* Main window */
	vpn_main = gtk_vpaned_new();
	gtk_box_pack_start(GTK_BOX (vbx_main), vpn_main, TRUE, TRUE, 0);

	ntb_work = gtk_notebook_new();
	gtk_notebook_append_page(GTK_NOTEBOOK (ntb_work), create_tab_search(), gtk_label_new("Results"));
	gtk_notebook_append_page(GTK_NOTEBOOK (ntb_work), create_tab_chat(), gtk_label_new("debian.se"));

	/* Main window, downloads */
	scrw_downloads = gtk_scrolled_window_new(NULL, NULL);
	gtk_paned_add1(GTK_PANED (vpn_main), ntb_work);
	gtk_paned_add2(GTK_PANED (vpn_main), scrw_downloads);

	/* Create the downloads example window */
	
	trvw_downloads = gtk_tree_view_new();

	/* Column #1 */
	trvw_crend = gtk_cell_renderer_text_new();
	gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW (trvw_downloads),
		-1, "Filename", trvw_crend, "text", DOWNLOADS_COL1_FILE, NULL);

	/* Column #2 */
	trvw_col = gtk_tree_view_column_new();
	trvw_crend = gtk_cell_renderer_text_new();
	gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW (trvw_downloads),
		-1, "Size", trvw_crend, "text", DOWNLOADS_COL2_SIZE, NULL);

	/* Column #3 */
	trvw_col = gtk_tree_view_column_new();
	trvw_crend = gtk_cell_renderer_text_new();
	gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW (trvw_downloads),
		-1, "Progress", trvw_crend, "text", DOWNLOADS_COL3_PROGRESS, NULL);

	/* Column #3 */
	trvw_col = gtk_tree_view_column_new();
	trvw_crend = gtk_cell_renderer_text_new();
	gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW (trvw_downloads),
		-1, "Speed", trvw_crend, "text", DOWNLOADS_COL4_PERCENT, NULL);

	
	/* Column #4 */
	trvw_col = gtk_tree_view_column_new();
	trvw_crend = gtk_cell_renderer_text_new();
	gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW (trvw_downloads),
		-1, "User", trvw_crend, "text", DOWNLOADS_COL5_USER, NULL);

	/* Column #5 */
	trvw_col = gtk_tree_view_column_new();
	trvw_crend = gtk_cell_renderer_text_new();
	gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW (trvw_downloads),
		-1, "Hub", trvw_crend, "text", DOWNLOADS_COL6_HUB, NULL);


	
	lstr_downloads = gtk_list_store_new(6, G_TYPE_STRING, G_TYPE_STRING,G_TYPE_STRING,
		G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
	gtk_list_store_append(lstr_downloads, &iter);
	gtk_list_store_set(lstr_downloads, &iter,
		DOWNLOADS_COL1_FILE, "Paris_Hilton_full.wmv",
		DOWNLOADS_COL2_SIZE, "123 Mb",
		DOWNLOADS_COL3_PROGRESS, "38%",
		DOWNLOADS_COL4_PERCENT, "238 kbps",
		DOWNLOADS_COL5_USER, "phuse",
		DOWNLOADS_COL6_HUB, "debian.se", -1);
	
	gtk_list_store_append(lstr_downloads, &iter);
	gtk_list_store_set(lstr_downloads, &iter,
		DOWNLOADS_COL1_FILE, "Thermaltake_ASGM31337.pdf",
		DOWNLOADS_COL2_SIZE, "4.2 Mb",
		DOWNLOADS_COL3_PROGRESS, "69%",
		DOWNLOADS_COL4_PERCENT, "120 kbps",
		DOWNLOADS_COL5_USER, "phuse",
		DOWNLOADS_COL6_HUB, "debian.se", -1);

	
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW (trvw_downloads), TRUE);
	gtk_tree_view_set_headers_clickable(GTK_TREE_VIEW (trvw_downloads), TRUE);
	
	gtk_tree_view_set_model(GTK_TREE_VIEW (trvw_downloads), GTK_TREE_MODEL (lstr_downloads));
	gtk_container_add(GTK_CONTAINER (scrw_downloads), trvw_downloads);

	/* Create and initalize the status bar */
	hbx_status = gtk_hbox_new(FALSE, 1);
	
	lbl_status_msg = gtk_label_new("Welcome to Wiredash");
	lbl_status_downl = gtk_label_new("Download: ");
	lbl_status_down = gtk_label_new("0 kbps");
	lbl_status_upl = gtk_label_new("Upload: ");
	lbl_status_up = gtk_label_new("0 kbps");
	printf("6\n");
	gtk_container_add(GTK_CONTAINER (mainwindow), vbx_main);
	
	printf("7\n");
	gtk_box_pack_end(GTK_BOX (vbx_main), hbx_status, FALSE, FALSE, 1);	
	gtk_box_pack_start(GTK_BOX (hbx_status), lbl_status_msg, FALSE, FALSE, 1); 
	gtk_box_pack_end(GTK_BOX (hbx_status), lbl_status_up, FALSE, FALSE, 1);
	gtk_box_pack_end(GTK_BOX (hbx_status), lbl_status_upl, FALSE, FALSE, 1);
	gtk_box_pack_end(GTK_BOX (hbx_status), lbl_status_down, FALSE, FALSE, 1);
	gtk_box_pack_end(GTK_BOX (hbx_status), lbl_status_downl, FALSE, FALSE, 1);
	printf("8\n");
	gtk_widget_show_all(mainwindow);
	

	gtk_main();

	return 0;
}

GtkWidget *create_tab_search (void)
{
	GtkWidget *ret;
	GtkWidget *vbx_left, *lbl_search, *btn_search, *etry_search, *cmb_search,
			  *chkb_onlyop;
	GtkWidget *trvw_right;
	
	vbx_left = gtk_vbox_new(FALSE, 0);
	trvw_right = gtk_tree_view_new();

	ret = gtk_hpaned_new();
	gtk_paned_add1(GTK_PANED (ret), vbx_left);
	gtk_paned_add2(GTK_PANED (ret), trvw_right);

	lbl_search = gtk_label_new("Search for...");
	gtk_box_pack_start(GTK_BOX (vbx_left), lbl_search, FALSE, FALSE, 0);

	etry_search = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX (vbx_left), etry_search, FALSE, FALSE, 5);

	cmb_search = gtk_combo_box_new_text();
	gtk_combo_box_append_text(GTK_COMBO_BOX (cmb_search), "All files");
	gtk_combo_box_append_text(GTK_COMBO_BOX (cmb_search), "Video");
	gtk_combo_box_append_text(GTK_COMBO_BOX (cmb_search), "Audio");
	gtk_combo_box_append_text(GTK_COMBO_BOX (cmb_search), "Images");
	gtk_combo_box_append_text(GTK_COMBO_BOX (cmb_search), "Programs");
	gtk_combo_box_set_active(GTK_COMBO_BOX (cmb_search), 0);	
	gtk_box_pack_start(GTK_BOX (vbx_left), cmb_search, FALSE, FALSE, 0);
	
	chkb_onlyop = gtk_check_button_new_with_label("Only hubs where I am OP");
	gtk_box_pack_start(GTK_BOX (vbx_left), chkb_onlyop, FALSE, FALSE, 5);

	btn_search = gtk_button_new_from_stock(GTK_STOCK_FIND);
	gtk_box_pack_end(GTK_BOX (vbx_left), btn_search, FALSE, FALSE, 5);

	return ret;
}

GtkWidget *create_tab_chat (void)
{
	GtkWidget *ret, *hpn_main;
	GtkWidget *vbx_main, *hbx_chatedit, *trvw_users, *txtv_chatbox,
		*etry_chatline, *btn_chatsend;

	ret = gtk_vbox_new(FALSE, 1);
	hpn_main = gtk_hpaned_new();

	txtv_chatbox = gtk_text_view_new();
	trvw_users = gtk_tree_view_new();
	gtk_paned_add1(GTK_PANED (hpn_main), txtv_chatbox);
	gtk_paned_add2(GTK_PANED (hpn_main), trvw_users);
	gtk_box_pack_start(GTK_BOX (ret), hpn_main, TRUE, TRUE, 5);
	
	hbx_chatedit = gtk_hbox_new(FALSE, 1);
	etry_chatline = gtk_entry_new();
	btn_chatsend = gtk_button_new_with_label("Send");
	gtk_box_pack_start(GTK_BOX (hbx_chatedit), etry_chatline, TRUE, TRUE, 0);
	gtk_box_pack_end(GTK_BOX (hbx_chatedit), btn_chatsend, FALSE, FALSE, 0);
	gtk_box_pack_end(GTK_BOX (ret), hbx_chatedit, FALSE, FALSE, 0);

	return ret;
}
